/*
    WN/SSL
    File: wn/wnssl.h
    Version 2.0-1
    
    Copyright (C) 1996  <by Elias Doumas>
    Copyright (C) 1998-2000 <by Matthias Cramer>

    Modified for WN 2.0 and OpenSSL by Matthias Cramer <cramer@freestone.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#define NOPROTO
#define WNSSL_ENVIRON
#define WMSSL_DEBUG


#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "wn.h"

#if WITHOPENSSL
#  include <openssl/ssl.h>
#  include <openssl/err.h>
#  include <openssl/x509.h>
#  include <openssl/pem.h>
#  include <openssl/crypto.h>
#  include <openssl/rand.h>
#else
#  include "ssl.h"
#  include "pem.h"
#endif



extern char   *ERR_error_string(),
              ssl_file_path[],
              ssl_buf[],
              env_cipher[],
              env_subject[],
              env_issuer[],
              env_serial[];

extern int    WN_read(),
              WN_write();
/*              ERR_get_error(); */

extern void   wnssl_opts(),
              wnssl_init(),
              wnssl_setup();

#define DEFAULT_SSL_PORT 443

#define is_ssl_fd(X,Y)    ( (SSL_get_fd((X))==0) || \
                            (SSL_get_fd((X))==1) || \
                            (SSL_get_fd((X))==(Y)) \
                          )

SSL *ssl_con;
SSL_CTX *ssl_ctx;
int ssl_debug_flag=0;
int ssl_only_flag=0;
int ssl_active_flag=0;
int ssl_verify_flag=SSL_VERIFY_NONE;
int standalone_debug=0;
X509 *ssl_public_cert;
RSA *ssl_private_key;

char *my_ssl_key_file=NULL;
char *my_ssl_cert_file=NULL;
